<template>
  <main
    :class="{ '_sides': sides }"
    class="grid-container"
    id="top">
    <Header v-if="!isIndex"/>
    <article
      class="appPage"
      :class="{ '_index': isIndex }">
      <Nuxt/>
    </article>
    <Footer/>
    <AppModalAuthorization
      v-scroll-lock="authModalShow"
      :visible="authModalShow"
      :error="error.modal"
      @clear-error="clearModalError"
      @login="onLogin"
      @createUser="createUser"
      @reset-password="onResetPassword"
      @before-close="onCloseAuthModal"/>

    <AppModalResetPassword
      v-scroll-lock="showResetPasswordModal"
      :visible="showResetPasswordModal"
      :error="error.modal"
      @before-close="hideResetPassword"/>

    <AppModalLocation
      v-scroll-lock="locationModalShow"
      :visible="locationModalShow"
      :location="location"
      @location-selected="locationSelected"
      @before-close="hideLocationModal"/>

    <AppModalBeginChat
      v-scroll-lock="beginChatModal"
      :visible="beginChatModal"
      @before-close="hideChatModal"/>

    <AppChatNoLogin
      :is-index="isIndex"
      v-if="!auth"/>

  </main>
</template>

<script>
import { get } from 'lodash-es';
import { createNamespacedHelpers, mapActions, mapState } from 'vuex';
import { SET_LOCATION } from '~/assets/js/store/root/action-types';
import { OPEN, CLOSE, LOADED } from '~/assets/js/store/chat/action-types';

import {
  SHOW_RESET_PASSWORD_MODAL,
  HIDE_RESET_PASSWORD_MODAL,
  HIDE_LOCATION_MODAL,
  HIDE_AUTH_MODAL,
  HIDE_BEGIN_CHAT_MODAL,
} from '~/assets/js/store/actionManager/mutation-types';
import { LOGIN } from '~/assets/js/store/user/action-types';
import { GeoLevel } from '~/backend/api-bundle/graphql/types';

import Header from '~/components/redesign/layout/header/header';
import Footer from '~/components/redesign/layout/footer/footer';
import AppModalAuthorization from '~/components/redesign/app-modals/app-modal-authorization';
import AppModalLocation from '~/components/redesign/app-modals/app-modal-location';
import AppModalResetPassword from '~/components/redesign/app-modals/app-modal-reset-password';
import AppModalBeginChat from '~/components/redesign/app-modals/app-modal-begin-chat';
import AppChatNoLogin from '~/components/redesign/layout/app-chat-no-login';

const STORE_ACTION_MANAGER = createNamespacedHelpers('actionManager');
const STORE_USER = createNamespacedHelpers('user');
const STORE_CHAT = createNamespacedHelpers('chat');

export default {
  components: {
    Header,
    Footer,
    AppModalAuthorization,
    AppModalResetPassword,
    AppModalLocation,
    AppModalBeginChat,
    AppChatNoLogin,
  },
  props: {
    isIndex: {
      type: Boolean,
      default: false,
    },
    sides: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      error: {
        modal: '',
      },
      favicon: {
        warn: false, // TRUE - анимация включена
        state: false, // TRUE - иконка письма, FALSE - обычная иконка
      },
    };
  },
  computed: {
    ...STORE_ACTION_MANAGER.mapState([
      'authModalShow',
      'showResetPasswordModal',
      'locationModalShow',
      'beginChatModal',
    ]),
    ...STORE_USER.mapState(['auth']),
    ...STORE_CHAT.mapState(['newMessages']),
    ...mapState(['location']),
    faviconHref() {
      return this.favicon.state ? '/favicon-mail.ico' : '/favicon.ico?v2';
    },
  },
  head() {
    const cnt = this.newMessages;
    const icon = this.faviconHref;
    const link = [
      {
        hid: 'icon', rel: 'icon', type: 'image/x-icon', href: icon,
      },
      { rel: 'stylesheet', href: 'https://fonts.googleapis.com/css?family=Montserrat:100,200,300,400,500,600,700,800,900' },
    ];

    return {
      titleTemplate: t => (cnt > 0 ? `У вас новые сообщения: ${cnt} шт - ${t}` : `${t}`),
      link,
    };
  },
  watch: {
    auth(val) {
      if (val === null) { // logout
        this.closeChat(window);
      } else { // login
        this.openChat(window);
      }
    },
    newMessages(val) {
      this.favicon.warn = val > 0;
    },
    'favicon.warn'(val) {
      this.setFavicon(val);
    },
  },
  created() {
    if (process.client) {
      this.loadChatScript(window).then(() => {
        if (this.auth) {
          this.openChat(window);
        }
      }).catch((err) => {
        console.log('CHAT script load error', err);
      });
      this.favicon.warn = this.newMessages > 0;

      // todo: можно использовать вычисления высоты браузерной части в мобилках vue-component
      // todo: https://github.com/Hiswe/vh-check

      // First we get the viewport height and we multiple it by 1% to get a value for a vh unit
      const vh = window.innerHeight * 0.01;
      // Then we set the value in the --vh custom property to the root of the document
      document.documentElement.style.setProperty('--vh', `${vh}px`);
    }
  },
  methods: {
    ...mapActions({
      setLocation: SET_LOCATION,
    }),
    ...STORE_USER.mapActions({
      login: LOGIN,
    }),
    ...STORE_ACTION_MANAGER.mapMutations({
      hideAuthModal: HIDE_AUTH_MODAL,
      hideLocationModal: HIDE_LOCATION_MODAL,
      showResetPass: SHOW_RESET_PASSWORD_MODAL,
      hideResetPassword: HIDE_RESET_PASSWORD_MODAL,
      hideChatModal: HIDE_BEGIN_CHAT_MODAL,
    }),
    ...STORE_CHAT.mapActions({
      loadChatScript: LOADED,
      openChat: OPEN,
      closeChat: CLOSE,
    }),
    async onLogin(payload) {
      try {
        await this.login(payload);
        this.hideAuthModal();
        // предмет ожесточённых споров
        // this.$router.push({ path: '/cabinet/wrench/profile' });
        return true;
      } catch (error) {
        const { data } = error.response;

        if (get(error, 'response.data.error.errorCode', null) === 401) {
          this.error.modal = get(data, 'message', '');
        } else {
          this.error.modal = 'Произошла ошибка, пожалуйста, попробуйте повторить запрос позднее';
        }
      }
      return false;
    },
    async createUser(payload) {
      const isUserCreate = await this.requestCreateUser(payload);
      if (isUserCreate) {
        if (payload.isOrganization) {
          this.$ym('modal_authorization_organization_sent');
        }
        const dataLogin = await this.onLogin(payload);

        if (dataLogin) {
          this.$router.push({ path: '/cabinet/wrench/profile' });
        }
      }

      return true;
    },
    async requestCreateUser(payload) {
      try {
        await this.$axios.$post('/_main/user/create', payload);

        return true;
      } catch (e) {
        console.log(e);

        if (get(e, 'response.data.error.errorCode', null) !== 500) {
          this.error.modal = e.response.data.message;
        } else {
          this.error.modal = `${e.response.data.message}<br>Cвяжитесь с Вашим менеджером или тех.поддержкой.`;
        }
        // TODO: Сделать модалку с кнопкой
        // this.showInfo({
        //   text: e.response.data.error.code !== 500
        //     ? `${e.response.data.message}</br>Cвяжитесь с Вашим менеджером или тех.поддержкой.`
        //     : e.response.data.message,
        //   buttonVisibility: e.response.data.error.code !== 500,
        //   buttonText: 'Написать в тех.поддержку',
        //   buttonUrl: '/about-us/contacts',
        // });
      }

      return false;
    },
    setFavicon(state) {
      this.favicon.state = state;
    },
    locationSelected(item) {
      // TODO: опасно,  может разъехаться сигнатура с state.location
      // как минимум - убрать под капот app-location-modal
      this.setLocation(item || {
        id: '',
        name: 'Все страны',
        prepositionalName: 'всех странах',
        level: GeoLevel.All,
        slug: 'all_city',
      });
      this.hideLocationModal();
    },
    onCloseAuthModal() {
      this.hideAuthModal();
      this.clearModalError();
    },
    onResetPassword() {
      this.hideAuthModal();
      this.showResetPass();
    },
    clearModalError() {
      this.error.modal = '';
    },
  },
};
</script>

<style lang="postcss">
  @import "~/assets/css/index.css";

  * {
    box-sizing: border-box;
  }

  html, body {
    margin: 0;
    padding: 0;
    background-color: #fff;
  }

  /* IOS FIX overflow-x:hidden */
  /* Проверять при обновлении nuxt */
  #__nuxt {
    overflow-x: hidden;
  }

  /*Alex_Czech workaround for Email/Phone iOS format-detection*/
  a[href^="x-apple-data-detectors:"] {
    color: #fff;
    text-decoration: none;
    pointer-events: none;
  }

  html {
    font-family: var(--font-regular);
    font-weight: var(--font-weight-regular);
    font-size: 16px;
    line-height: 1.4;
    /*пока выключим! Если будут проблемы с текстом на мобилках и iOS*/
    /*-ms-text-size-adjust: 100%;*/
    /*-webkit-text-size-adjust: 100%;*/
  }

  body {
    height: auto;
    min-height: 100vh;
    overflow-x: hidden;
  }

  ul {
    margin: 0;
    padding: 0;
    list-style: none;
  }

  a {
    text-decoration: none;
    outline: none;
    cursor: pointer;
  }

  button, input, p, ul, ol, li, a {
    font-family: var(--font-regular);
  }

  .grid-container {
    display: grid;
    grid-template-columns: 100%;
    grid-template-rows: auto 1fr auto auto;
    grid-template-areas: "header" "page" "footer";
    min-height: 100vh;
    background-image: linear-gradient(45deg, rgba(17,65,89,1) 0%,rgba(10,92,125,1) 51%,rgba(16,125,163,1) 100%);

    .appHeader {
      grid-area: header;
    }

    .appPage {
      grid-area: page;
      background-color: var(--bg-main);
    }

    &._sides {
      .appPage {
        margin: 0 3.25rem;
      }
    }

    .appFooter {
      grid-area: footer;
      position: relative;
    }
  }

  @media only screen and (max-width: 980px) {
    .grid-container {
      &._sides {
        .appPage {
          margin: 0;
        }
      }
    }
  }

  .roomVideoChat-mainbtn {
    z-index: calc(var(--z-index-under-modal) - 1) !important;
    margin-right: var(--scroll-bar-gap);
  }

  .mobilshow {
    @media only screen and (min-width: 981px) {
      display: none !important;
    }
  }

  .desktopshow {
    @media only screen and (max-width: 980px) {
      display: none !important;
    }
  }

  /*https://github.com/sindresorhus/modern-normalize/issues/19*/
  @media screen and (-webkit-min-device-pixel-ratio: 2), screen and (min-resolution: 2dppx) {
    body {
      -moz-osx-font-smoothing: grayscale;
      -webkit-font-smoothing: antialiased;
    }
  }

  /* временный костыль - убрать, когда все стили будут в rem */

  @media (min-width: 1201px) and (max-width: 1365px) {
    html {
      font-size: 1.17vw !important;
    }
    // body {
    //   zoom: 85%;
    // }
//
    // /*только для Mozilla Firefox т.к. zoom не работает*/
    // @-moz-document url-prefix() {
    //   body {
    //     margin: 0 -9vw;
    //     -moz-transform: scale(0.85);
    //     -moz-transform-origin: top center;
    //   }
    // }
  }
</style>
